void draw()
{
  switch(gnColorMode)  {
            case 0:
              background(255);
              break;
              
            case 1:
              background(0);
              break;
            }
        
  //background(250); //set background color

  // list of months
  for (int i = 0; i<12; i++) { // iterate integer i from 0-30
    textFont(gFont1); // set font style
    switch(gnColorMode) {
      case 0:
        fill(0); // set font color
        break;
      case 1:
        fill(255);
        break;
    }
    textAlign(CENTER, CENTER); // align text (alignX, alignY)
    // write text of a list of days here. (text contents(1-31), X position of texts, Y position of texts)
    text(str(i+1), (i*BarSize_X)+BarPos_X, height-BarPos_Y);
  }

  // list of media_types
  for (int i = 0; i<media_types.length; i++) { // iterate integer i from 0-10 (same to the length of media_types strings)
    textFont(gFont1); // set font style
    switch(gnColorMode) {
      case 0:
        fill(0); // set font color
        break;
      case 1:
        fill(255);
        break;
    }
    textAlign(RIGHT, CENTER); // align text (alignX, alignY)
    // write text of a list of dewey here. (text 10 deweyclass from String called dewey[i], X position of texts, Y position of texts)
    text(media_types[i], BarPos_X-30, (i*BarSize_Y)+BarPos_Y+40);
  }
  //popMatrix();

  // Title and copyright
  textFont(gFont2); // set font style
  textAlign(CENTER, CENTER); // align text (alignX, alignY)
  switch(gnColorMode) {
      case 0:
        fill(0); // set font color
        break;
      case 1:
        fill(255);
        break;
    }
  text("Simple 2D Spatial Visualization - Media Type Popularity", 0, 0, width, 80); // text with its position

  textFont(gFont1); // set font style
  textAlign(CENTER, CENTER); // align text (alignX, alignY)
  text("Top 10 Media Types in 2013", 150, height/2); // text
  text("Months of 2013", width/2, height-40); // text with its position

  textAlign(RIGHT, BOTTOM); // align text (alignX, alignY)
  switch(gnColorMode) {
      case 0:
        fill(0); // set font color
        break;
      case 1:
        fill(255);
        break;
    } // set font color
  text("by Kevin Deweese | MAT259 Winter 2014", 0, 0, width-10, height-10); // text with its position

  // draw each bars
  for ( int i=0; i<gDataMatrices.length; i++ ) {

    for (int j=1; j<gDataMatrices[i].length; j++) {  // year
      
      //for (int k=0; k<gDataMatrices[i][j].length; k++) {  // days

        // normalize color
        //int nColor = (int)((float)gDataMatrices[i][j]/(float)max(gDataMatrices[i])*255.0f);  // mode 1
        float nColor = gDataMatrices[i][j];///max(gDataMatrices[i])*255.0f;
        
        
        // non-nomarlized color - original color
        //int nColor = (int)((float)gDataMatrices[i][j][k]/(float)gMaxValue*255.0f);  // mode 1
        
        float mColor;
        if(nColor > 0) {
          mColor = map(nColor, 0, gMaxValue, 0, 255); // remap the color inversely (black-white)
        }
        else {
          mColor = map(nColor, -gMaxValue, 0, 255, 0);
        }  
        
        // these are different colorsets - feel free to modify/use/test this
        //int nHue = (int)(240.0f - (float)gDataMatrices[i][j][k]/(float)gMaxValue*240.0f);  // mode2
        //float nColor2 = map(nColor, 0, 255, 50, 255); // mode3
        //float nColor3 = map(nColor, 0, 255, 30, 255); // mode3

        strokeWeight(0.2); //strokeweigth of bars
        stroke(150); //stroke color of bars
        //fill(mColor, mColor, mColor); // color of bars
        
        if( gpBarsMouseEvent[i][j-1] == true )  {
          
          switch(gnColorMode)  {
            case 0:
              fill(0, 0, 0);
              break;
              
            case 1:
              fill(255,255,255);
              break;
          }
        }
        else {
          if(nColor > 0) {
            switch(gnColorMode) {
              case 0:
                fill(255-mColor, 255, 255-mColor);
                break;
              case 1:
                fill(0, mColor, 0);
                break;
            }  
          }
          else if(nColor < 1) {
            switch(gnColorMode) {
                case 0:
                  fill(255,255-mColor,255-mColor);
                break;
                case 1:
                  fill(mColor,0,0);
                break;
            }  
          }
          else {
            fill(255,255,255);
          }
        }
        // position and size of bars (x position of bars, y position of bars, width of bars, height of bars) 
        rect(BarSize_X*(j-1)+BarPos_X, BarSize_Y*i+BarPos_Y, BarSize_X, BarSize_Y);  

      //}  // for k

    }  // for j

  }  // for i
  
  textFont(gFont1);
  textAlign(RIGHT,TOP);
  for(int i=1; i<13; i++) {
    for(int k=0; k<gDataMatrices.length; k++) {
      if(gpBarsMouseEvent[k][i-1] == true) {  
        String strText = nfp(gDataMatrices[k][i],1,5);
        int nTextX = BarPos_X + (i-2)*(BarSize_X) - BarSize_X*2;
        int nTextY = BarPos_Y + k *(BarSize_Y) - 20;
        int nTextWidth = BarSize_X*4;
        int nTextHeight = 20;
        switch(gnColorMode) {
          case 0:
            fill(0); // set font color
            break;
          case 1:
            fill(255);
            break;
        }
        text(strText, nTextX+1, nTextY+1, nTextWidth+1, nTextHeight+1);
        fill(255,0,0);
      }
    } 
  }
  
}

