void setup()
{

  size(1024, 750); // set canvas size
  smooth(); // anti-aliased (check this: http://processing.org/reference/smooth_.html)

  gFont1 = createFont("Arial", 11, true); // specify font1
  gFont2 = createFont("Helvetica", 18, true); // specify font2
  gFont3 = createFont("Arial", 15, true); // specify font1

  // for files:
  // for year: 2008-2008 => idx: 0-0
  // for day: 1-31 => 0-30
  // better implementation
  gDataMatrices = new float[10][13];  // no need to initialization
  gpBarsMouseEvent = new boolean[gDataMatrices.length][12];
  // get data
  for (int i=0; i<gFilenames.length; i++ ) {

    // read local files
    println("reading "+gFilenames[i]+"...");

    // LoadStrings (check this: http://processing.org/reference/loadStrings_.html)
    String [] textData = loadStrings(gFilenames[i]); //Reads the contents of a file and creates a String array of its individual lines.

    for ( int j=1; j<textData.length; j++ ) {  // we start from second line because the first line is query.

      // split (check this: http://processing.org/reference/split_.html)
      String textSplitted[] = split(textData[j], ","); // break strings from comma

      //int y = (int)Integer.parseInt(textSplitted[0]); // get and store the first column (year) into int.
      //int m = (int)Integer.parseInt(textSplitted[1]); // get and store the second column (day) into int.
      //int val = (int)Integer.parseInt(textSplitted[2]); // get and store the third column (count number) into int.
      //String media = texSplitted[0];
      int count = (int)Integer.parseInt(textSplitted[1]);

      gDataMatrices[j-1][i] = count; // store the total count number in the matrices.
    }
  }
  
  float[] average = new float[10];

  for (int i=0; i < 10; i++) {
    average[i] = gDataMatrices[i][0]/12.0;
  }

  for(int i=0; i < 10; i++) {
    for(int j=1; j < 13; j++){
      gDataMatrices[i][j] = (gDataMatrices[i][j]-average[i])/average[i];
    }
     
  }

  // find max value
  for ( int i=0; i<gDataMatrices.length; i++ ) {
    for ( int j=1; j<gDataMatrices[i].length; j++ ) {
      if ( gMaxValue < abs(gDataMatrices[i][j]) ) {
        gMaxValue = abs(gDataMatrices[i][j]);
      }
    }
  }

 
}

